; Wibarm (for IBM-PC/AT,TANDY)  (C)Broderbund
; C[` (for NASM)

%include 'hoot.inc'

		ORG	0x0100
		USE16
		CPU	186

nearcallmod	equ	0xa24d			; near callpAJ[zuItZbg
mdata_ofs	equ	0x0000			; ȃf[^zuItZbg

PROG_HUNDLE	equ	0x0005			; CvOpt@Cnh
DATA_HUNDLE	equ	0x0006			; ̑f[^pt@Cnh
MUSIC_HUNDLE	equ	0x0010			; ^Cgȃf[^pt@Cnh
MUSIC_HUNDLE2	equ	0x0011			; ̑ȃf[^pt@Cnh

start:		cli
		cld
		mov	sp,stack
		mov	bx,prgend
		shr	bx,4
		mov	ah,0x4a			; [DOS] ubN̏k(ES:BX)
		int	0x21
		jnc	.skip1
		hlt

.skip1:		mov	bx,0x2000		; 傫128K
		mov	ah,0x48			; [DOS] 蓖
		int	0x21
		jnc	.skip2
		hlt
.skip2:		mov	[cs:progseg],ax		; 蓖ăAhXۑ
		mov	es,ax
		mov	bx,ax
		add	ax,0x0a25		; f[^ZOgo^
		mov	[cs:dataseg],ax

		xor	di,di			; 蓖Ă[NA
		xor	ax,ax
		xor	cx,cx
		rep	stosw

prgload:	mov	bx,PROG_HUNDLE		; CvÕt@Cnh
		xor	cx,cx			; wb_ǂݔ΂߂ɃV[N
		mov	dx,0x0008
		mov	ax,0x4200
		int	0x21

		mov	ds,[cs:progseg]
		xor	dx,dx			; CvO[hAhX
		mov	ah,0x3f			; [DOS] read hundle (DS:DX)
		mov	cx,0xffff
		int	0x21			; CvO[h

		mov	bx,DATA_HUNDLE		; DATADAT.DAT̃[h
		mov	ds,[cs:dataseg]
		mov	dx,0xe300
		mov	cx,0x0490
		mov	ah,0x3f
		int	0x21

		mov	ax,cs
		mov	ds,ax
		mov	si,nearcallagent
		mov	cx,nearcallagentsize
		mov	es,[cs:progseg]
		mov	di,nearcallmod
		rep	movsb			; far callpGg]

		mov	ds,[cs:progseg]
		mov	dx,0x09b8
		mov	ax,0x2508		; ^C}݃tbN
		int	0x21

		mov	ds,[cs:dataseg]
		mov	ax,[cs:progseg]
		mov	[0xf4fd],ds
		mov	word [0xf416],mdata_ofs	; ȃf[^AhX

		mov	ax,0xf000		; TANDY BIOSݔ
		mov	es,ax
		cmp	byte [es:0xc000],0x21
		jnz	pit_set
		mov	byte [0xf4f8],0x01	; TANDYdlƂ

pit_set:	mov	al,0x88			; PIT #0 JE^Zbg
		out	0x40,al
		mov	al,0x0f
		out	0x40,al
		in	al,0x21			; PICݒ
		or	al,0xb8
		out	0x21,al

		mov	ax,cs
		mov	ds,ax
		mov	es,ax
		mov	ax,0x253c		; INT 3C({̃^C})tbN
		mov	dx,dummy_int
		int	0x21
		mov	ax,0x257f		; hoothCoo^
		mov	dx,vect_7f
		int	0x21

		sti
mainloop:	mov	ax,0x9801		; _~[|[O
		int	0x18
		jmp	short mainloop

; hootR[
; inp8(HOOTPORT) = 0  PC98DOS::Play
; inp8(HOOTPORT) = 2  PC98DOS::Stop
; _code = inp8(HOOTPORT+2)`inp8(HOOTPORT+5)

vect_7f:	pusha
		push	ds
		push	es
		mov	ds,[cs:dataseg]
		mov	dx,HOOTPORT
		in	al,dx
		cmp	al,HP_PLAY
		jz	short .play
		cmp	al,HP_STOP
		jz	short .stop
.ed:		pop	es
		pop	ds
		popa
		iret

.play:		mov	ax,0x1112		; t~
                call	far [cs:nearcallentry]

		mov	dx,HOOTPORT+2		; ȃf[^pt@Cnhǂݎ
		in	al,dx
		xchg	bl,al
		xor	bh,bh
		xor	cx,cx			; t@C擪ɃV[N
		xor	dx,dx
		mov	ax,0x4200
		int	0x21

		mov	dx,0xd000		; wb_ǂݍ݃AhX
		mov	si,dx
		mov	cx,0x0200		; wb_TCY
		mov	ah,0x3f
		int	0x21			; wb_ǂݍ

		mov	dx,HOOTPORT+3		; ȃf[^ԍ擾
		in	al,dx
		xor	ah,ah
		shl	ax,3			; x8
		add	si,ax
		mov	dx,[si]			; t@CItZbg擾
		mov	cx,[si+2]
		or	dx,cx
		jz	.ed			; w̋ȃf[^Ȃꍇ͉Ȃ
		mov	ax,0x4200
		int	0x21			; t@CV[N

		mov	cx,[si+4]		; t@CTCY擾
		mov	dx,mdata_ofs		; [hAhX
		mov	ah,0x3f
		cli
		int	0x21			; ȃf[^[h

		mov	ax,0x119e		; tJn
		call	far [cs:nearcallentry]
		sti
		jmp	short .ed

.stop:		mov	ax,0x1112		; t~
		call	far [cs:nearcallentry]
		jmp	short .ed

dummy_int:	mov	al,0x20			; _~[EOIs
		out	0x20,al
		iret

nearcallentry:	dw	nearcallmod
progseg:	dw	0

dataseg:	dw	0

; near callpAJ[
nearcallagent:	call	ax
		retf

nearcallagentsize	equ	$ - nearcallagent

		times 0x200 db 0x00		; X^bNGA
stack:

		align	0x10
prgend:		

		ends

